#include "StdAfx.h"
#include "BmpTool.h"

#define BYTESPERLINE(Width, BPP) ((WORD)((((DWORD)(Width) * (DWORD)(BPP) + 31) >> 5)) << 2) 

void CBmpTool::Load( char* p_szFilename )
{
	HANDLE hFile = ::CreateFile( p_szFilename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL );

	if ((int)hFile == -1){
		printf("File %s not found\n",p_szFilename);
		exit(1);
	}

	DWORD dwFileSize = ::GetFileSize( hFile, NULL );
	BYTE* buff = new BYTE[ dwFileSize ];

	::ReadFile( hFile, buff, dwFileSize, &dwFileSize, NULL );
	::CloseHandle( hFile );

	BITMAPFILEHEADER* pFI = (BITMAPFILEHEADER*)buff;
   
	if(pFI->bfType == 0x4D42)
	{
		BITMAPINFO* pBMI = (BITMAPINFO*)(buff + sizeof(BITMAPFILEHEADER));
		memcpy( &m_BMI, pBMI, sizeof(BITMAPINFO));

		if(pBMI->bmiHeader.biCompression!=0)
			return;

		BYTE* data = buff + pFI->bfOffBits;

		if(pBMI->bmiHeader.biSizeImage==0)
		{
			pBMI->bmiHeader.biSizeImage = BYTESPERLINE( pBMI->bmiHeader.biWidth, pBMI->bmiHeader.biBitCount ) * pBMI->bmiHeader.biHeight;
		}

		m_hBmp = ::CreateDIBSection( NULL, pBMI, DIB_RGB_COLORS, (LPVOID*)&m_pData, NULL, 0 );
		memcpy( m_pData, data, dwFileSize - pFI->bfOffBits );
	}
}
